/*
 * Copyright (c) 2019 University of Colorado
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 * Author: Derek Hageman <Derek.Hageman@noaa.gov>
 */
#ifndef CPD3EDITINGDATATARGET_H
#define CPD3EDITINGDATATARGET_H

#include "core/first.hxx"

#include <QtGlobal>
#include <QString>

#include "editing/editing.hxx"
#include "datacore/stream.hxx"

namespace CPD3 {
namespace Editing {

/**
 * The general target for data in the editing chain.
 */
class CPD3EDITING_EXPORT EditDataTarget {
public:
    EditDataTarget();

    virtual ~EditDataTarget();

    /**
     * Handle an incoming data value.
     * 
     * @param value the incoming value
     */
    virtual void incomingSequenceValue(const Data::SequenceValue &value) = 0;
};

/**
 * A target in the editing chain that applies an immediate modification.
 */
class CPD3EDITING_EXPORT EditDataModification {
public:
    EditDataModification();

    virtual ~EditDataModification();

    /**
     * Handle an incoming data value.
     * 
     * @param value the incoming value
     */
    virtual void modifySequenceValue(Data::SequenceValue &value) = 0;
};

/**
 * A target for data between dispatching stages in the directive list.
 */
class CPD3EDITING_EXPORT EditDispatchTarget {
public:
    EditDispatchTarget();

    virtual ~EditDispatchTarget();

    /**
     * Handle an incoming data value.
     * 
     * @param value     the incoming value
     */
    virtual void incomingData(const Data::SequenceValue &value) = 0;

    /** @see incomingData(const Data::SequenceValue &) */
    virtual void incomingData(Data::SequenceValue &&value);

    /**
     * Handle a list of incoming values.
     * 
     * @param values    the incoming values
     */
    virtual void incomingData(const Data::SequenceValue::Transfer &values);

    /** @see incomingData(const Data::SequenceValue::Transfer &) */
    virtual void incomingData(Data::SequenceValue::Transfer &&values);

    /**
     * Handling an advance in the time.
     * 
     * @param time      the time to advance to
     */
    virtual void incomingAdvance(double time);
};

class CPD3EDITING_EXPORT EditDispatchSkipTarget : public EditDispatchTarget {
public:
    EditDispatchSkipTarget();

    virtual ~EditDispatchSkipTarget();

    /**
     * Handle incoming data that has skipped from further up the chain.
     * 
     * @param value     the value to handle
     * @param origin    the originating data source (unique for the chain)
     */
    virtual void incomingSkipped(const Data::SequenceValue &value, void *origin) = 0;

    /** @see incomingSkipped(const Data::SequenceValue &, void *) */
    virtual void incomingSkipped(Data::SequenceValue &&value, void *origin);

    /**
     * Handle incoming data that has skipped from further up the chain.
     * 
     * @param values    the values to handle
     * @param origin    the originating data source (unique for the chain)
     */
    virtual void incomingSkipped(const Data::SequenceValue::Transfer &values, void *origin);

    /** @see incomingSkipped(const Data::SequenceValue::Transfer &, void *) */
    virtual void incomingSkipped(Data::SequenceValue::Transfer &&values, void *origin);

    /**
     * Handle an incoming advance that has skipped from further up the chain
     * 
     * @param time      the time to advance until
     * @param origin    the originating data source (unique for the chain)
     */
    virtual void incomingSkipAdvance(double time, void *origin);

    /**
     * Handle the end of possible incoming data from further up the chain.  
     * After this is called no more data will be generated by the given
     * origin.
     * 
     * @param origin    the originating data source (unique for the chain)
     */
    virtual void incomingSkipEnd(void *origin);
};

}
}

#endif
